#!/usr/bin/perl
#####################################################################################
# Copyright IMAX Scripts 2002. All Rights Reserved                                  #
#                                                                                   #
# This program is copyrighted software. It may not be modified, distributed or sold #
# without prior written consent from the copyright holder.                          #
#                                                                                   #
# Any use of this script is entirely at the risk of the user. No liability will be  #
# accepted by the author.                                                           #
#                                                                                   #
######################NOTHING BELOW THIS LINE NEEDS TO BE EDITED#####################

use Fcntl qw/:flock/;

if (!$ENV{'HTTP_COOKIE'}){
print "Content-type: text/html", "\n\n";
print "This link requires that cookies be enabled in your browser...";
exit(0);
}
foreach (split(/; /,$ENV{'HTTP_COOKIE'})) {
($name,$value) = split(/=/);
$cookie{$name} = $value;
}
open (FILE, "+<exchange_data/exchange.dat") || die "Cannot open exchange database: $!";
flock(FILE, LOCK_EX) || die "Cannot get exclusive lock on exchange database: $!";
while(<FILE>){
chomp($_);
    (
        $user_name, $banner_url, $site_url, $status,
        $cat,       $credits,    $clicks,   $waiting_credits,
        $shown,     $c_shown,    $ratio,    $site_title,
        $name,      $email,      $last_display, $password
      ) = split(/\|/,$_);
  if ($user_name eq $cookie{'shown_member'}){
      $clicks++;
}
@values = ( $user_name, $banner_url, $site_url, $status,
            $cat,       $credits,    $clicks,   $waiting_credits,
            $shown,     $c_shown,    $ratio,    $site_title,
            $name,      $email,      $last_display, $password
          );
$values = join("\|",@values);
push(@updated, $values);
}
seek FILE, 0, 0;
truncate FILE, 0;
foreach $updated(@updated){
print (FILE "$updated\n");
}
close(FILE);

    open( STATS, "+<exchange_data/exchange_stats.dat" )
      || bail("Cannot open exchange stats database");
    flock( STATS, LOCK_EX )
      || bail("Cannot get exclusive lock on exchange stats database");
    while (<STATS>) {
        ( $default_display, $default_clicks,
	  $ad_display,      $ad_clicks,
	  $member_display,  $member_clicks,
	  $total_displays,  $total_clicks
	  )
	   = split ( /\|/, $_ );
           if( $cookie{'type_click'} eq 'default'){$default_clicks++;}
	   if( $cookie{'type_click'} eq 'ad'){$ad_clicks++;}
	   if( $cookie{'type_click'} eq 'member'){$member_clicks++;}
	   $total_clicks++;
	   @stats =
          ( $default_display, $default_clicks,
	    $ad_display,      $ad_clicks,
	    $member_display,  $member_clicks,
	    $total_displays,  $total_clicks
	  );
        $stats = join ( "\|", @stats );
    seek STATS, 0, 0;
    truncate STATS, 0;
    print( STATS "$stats" );
    close(STATS);
}

print "Location: $cookie{'site_url'}\n\n";

exit(0);

